//+------------------------------------------------------------------+
//|                                                       ha offline |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
#property indicator_chart_window

#include <WinUser32.mqh>
#import "user32.dll"
      int GetParent(int hWnd);
   int RegisterWindowMessageA(string lpString);
#import

//
//
//
//
//

extern int TimeFrame    = 10;
extern int DisplayDelay = 0;

//
//
//
//
//7

int      fileHandle = -1;
int      filePeriod =  1;
string   fileSymbol;

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];

//+------------------------------------------------------------------
//
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0, ExtMapBuffer1); SetIndexStyle(0,DRAW_NONE);
   SetIndexBuffer(1, ExtMapBuffer2);
   SetIndexBuffer(2, ExtMapBuffer3);
   SetIndexBuffer(3, ExtMapBuffer4);
   fileSymbol  = Symbol();
   filePeriod  = TimeFrame;
   OpenHistoryFile();
   return (0);
}

//
//
//
//
//

void deinit()
{
   if (fileHandle >= 0) { FileClose(fileHandle); fileHandle = -1; }
}

//+------------------------------------------------------------------
//
//+------------------------------------------------------------------
//
//
//
//
//

int OpenHistoryFile()
{
   string name = fileSymbol+filePeriod;
          fileHandle = FileOpenHistory(name + ".hst", FILE_BIN|FILE_WRITE);  if (fileHandle >= 0) FileClose(fileHandle);
          fileHandle = FileOpenHistory(name + ".hst", FILE_BIN|FILE_WRITE|FILE_READ);

      //
      //
      //
      //
      //
       
      if (fileHandle >=0)
      {
         if (FileSize(fileHandle)<148) WriteHistoryHeader();
         return(0);
      }
      else return(-1);
}

//
//
//
//
//

int WriteHistoryHeader()
{
   string c_copyright  = "(C)opyright 2003, MetaQuotes Software Corp.";
   int    digits       = Digits;
   int    version      = 400;   
   int    unused[13];

   if (fileHandle >= 0)
   {
      FileWriteInteger(fileHandle, version, LONG_VALUE);
      FileWriteString(fileHandle, c_copyright, 64);
      FileWriteString(fileHandle, fileSymbol , 12);
      FileWriteInteger(fileHandle, filePeriod, LONG_VALUE);
      FileWriteInteger(fileHandle, digits    , LONG_VALUE);
      FileWriteInteger(fileHandle, 0         , LONG_VALUE);
      FileWriteInteger(fileHandle, 0         , LONG_VALUE);  // last synchronization
      FileWriteArray(fileHandle, unused,0,13);
              FileFlush(fileHandle);
   }
   return (0);
}

//
//
//
//
//

#define recordSize 44
void WriteHistoryData(double open, double close, double high, double low, double volume, datetime time)
{
   if (fileHandle >= 0)
   {
      FileFlush(fileHandle);
      bool found = FileSeek(fileHandle,0,SEEK_END);
   
      //
      //
      //
      //
      //
      
            if (found)
            {
               int size = FileTell(fileHandle);
               if (size>=192 && time!=0)
               {
                  int rec = 1;
                  int pos = 145;
                  int poo = 145;
                  int err = 0;
                  while (true && pos>144 && rec<3)
                  {
                        pos = size-( rec   *recordSize);
                        poo = size-((rec-1)*recordSize);
                           FileSeek(fileHandle,pos,SEEK_SET);
                              datetime tT = FileReadInteger(fileHandle,LONG_VALUE);
                                 if (tT==time ) { found = FileSeek(fileHandle,pos,SEEK_SET); break; }
                                 if (tT <time ) { found = false;                             break; }
                           rec++;                                       
                  }       
                  if (!found) found = FileSeek(fileHandle,0,SEEK_END);
               }                         
               else found = FileSeek(fileHandle,0,SEEK_END);
            }               
            if (found)         
            {
               FileWriteInteger(fileHandle, time,  LONG_VALUE  );  //    time
               FileWriteDouble(fileHandle,  open,  DOUBLE_VALUE);  //    open
               FileWriteDouble(fileHandle,  low,   DOUBLE_VALUE);  //    low
               FileWriteDouble(fileHandle,  high,  DOUBLE_VALUE);  //    high
               FileWriteDouble(fileHandle,  close, DOUBLE_VALUE);  //    close
               FileWriteDouble(fileHandle,  volume,DOUBLE_VALUE);  //    volume
            }               
         
         //
         //
         //
         //
         //
         
         FileFlush(fileHandle);
   }
}

//+------------------------------------------------------------------
//
//+------------------------------------------------------------------
//
//
//
//
//

#define CHART_CMD_UPDATE_DATA 33324

//
//
//
//
//

void UpdateChartWindows()
{
   if (fileHandle < 0) return;

   //
   //
   //
   //
   //

      static int MT4msgIdentifier=0;
      static datetime lastRefresh   = 0; 
               string chartName     = fileSymbol+",M"+filePeriod+" (offline)";
               string stringForName = "                                                                                "; 
               if ((TimeLocal()-lastRefresh)<DisplayDelay) return;
                                lastRefresh=TimeLocal();
               if(MT4msgIdentifier == 0) MT4msgIdentifier = RegisterWindowMessageA("MetaTrader4_Internal_Message");
               
      //
      //
      //
      //
      //


      int windowHandle = WindowHandle(fileSymbol,filePeriod);
      if (windowHandle != 0)
      {
         PostMessageA(windowHandle,MT4msgIdentifier,2,1);
         windowHandle = GetParent(windowHandle);
         windowHandle = GetWindow(windowHandle,GW_HWNDFIRST);
         while (windowHandle != 0)
         {

            //
            //
            //
            //
            //
            
            int len = GetWindowTextA(windowHandle,stringForName,80);
            if (len > 0 && StringSubstr(stringForName,0,len) == chartName)
               {
                        PostMessageA(windowHandle,WM_COMMAND,CHART_CMD_UPDATE_DATA,0);
                        PostMessageA(windowHandle,MT4msgIdentifier,2,1);
               }                        
            windowHandle = GetWindow(windowHandle,GW_HWNDNEXT);
         }
      }
}

//+------------------------------------------------------------------
//
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //


   for(i=limit; i>=0; i--)
   {
   
       double haOpen  = (ExtMapBuffer3[i+1] + ExtMapBuffer4[i+1]) / 2;
       double haClose = (Open[i] + High[i] + Low[i] + Close[i]) / 4;
       double haHigh  = MathMax(High[i], MathMax(haOpen, haClose));
       double haLow   = MathMin(Low[i], MathMin(haOpen, haClose));
          ExtMapBuffer1[i] = haHigh;
          ExtMapBuffer2[i] = haLow;
          ExtMapBuffer3[i] = haOpen;
          ExtMapBuffer4[i] = haClose;
          WriteHistoryData(haOpen,haClose,haHigh,haLow,Volume[i],Time[i]);
   }
   UpdateChartWindows();
}